blob: 7e42f10933109a7fc5b87c58c091cfc1f6101f5d [file] [log] [blame]
Peter Tyserf2352872009-12-06 23:58:28 -06001#!/bin/bash
Wolfgang Denk0777eaf2010-10-17 12:26:48 +02002# Tool mainly for U-Boot Quality Assurance: build one or more board
3# configurations with minimal verbosity, showing only warnings and
4# errors.
Wolfgang Denkeca3aeb2013-06-21 10:22:36 +02005#
6# SPDX-License-Identifier: GPL-2.0+
Wolfgang Denk0777eaf2010-10-17 12:26:48 +02007
Mike Frysingerd8e392d2011-04-21 22:01:43 +00008usage()
9{
10 # if exiting with 0, write to stdout, else write to stderr
11 local ret=${1:-0}
12 [ "${ret}" -eq 1 ] && exec 1>&2
13 cat <<-EOF
14 Usage: MAKEALL [options] [--] [boards-to-build]
15
16 Options:
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
Masahiro Yamada4d1584b2013-11-21 19:06:58 +090021 -b BOARD, --board BOARD Build all boards with board name BOARD
Marek Vasut7f79c6f2011-12-02 21:32:03 +000022 -l, --list List all targets to be built
Marek Vasut9b96c6b2012-03-05 15:10:51 +000023 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails
Kim Phillips33f336d2012-09-27 14:57:34 +000025 -C, --check Enable build checking
Joe Hershberger08510202012-10-30 15:55:21 +000026 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored
Mike Frysingerd8e392d2011-04-21 22:01:43 +000028 -h, --help This help output
29
30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info.
35
36 If no boards are specified, then the default is "powerpc".
37
38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
Allen Martin47104c32013-01-29 14:34:58 +000041 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
Wolfgang Denk93e14592013-10-04 17:43:24 +020042 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "")
Mike Frysingerd8e392d2011-04-21 22:01:43 +000044 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./)
Andy Flemingf588bb02012-04-24 19:33:51 +000046 BUILD_NBUILDS number of parallel targets (default: 1)
Mike Frysingerd8e392d2011-04-21 22:01:43 +000047
48 Examples:
49 - build all Power Architecture boards:
50 MAKEALL -a powerpc
51 MAKEALL --arch powerpc
52 MAKEALL powerpc
53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx
59 EOF
60 exit ${ret}
61}
62
Simon Glassf4815762014-08-28 09:43:46 -060063deprecation() {
64 echo "** Note: MAKEALL is deprecated - please use buildman instead"
65 echo "** See tools/buildman/README for details"
66 echo
67}
68
69deprecation
70
Masahiro Yamada4d1584b2013-11-21 19:06:58 +090071SHORT_OPTS="ha:c:v:s:b:lmMCnr"
72LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020073
74# Option processing based on util-linux-2.13/getopt-parse.bash
75
Wolfgang Denk071bc922010-10-27 22:48:30 +020076# Note that we use `"$@"' to let each command-line parameter expand to a
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020077# separate word. The quotes around `$@' are essential!
78# We need TEMP as the `eval set --' would nuke the return value of
79# getopt.
80TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
81 -n 'MAKEALL' -- "$@"`
82
Mike Frysingerd8e392d2011-04-21 22:01:43 +000083[ $? != 0 ] && usage 1
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020084
85# Note the quotes around `$TEMP': they are essential!
86eval set -- "$TEMP"
87
88SELECTED=''
Marek Vasut7f79c6f2011-12-02 21:32:03 +000089ONLY_LIST=''
Marek Vasut9b96c6b2012-03-05 15:10:51 +000090PRINT_MAINTS=''
91MAINTAINERS_ONLY=''
Joe Hershberger08510202012-10-30 15:55:21 +000092CONTINUE=''
93REBUILD_ERRORS=''
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020094
95while true ; do
96 case "$1" in
97 -a|--arch)
98 # echo "Option ARCH: argument \`$2'"
99 if [ "$opt_a" ] ; then
100 opt_a="${opt_a%)} || \$2 == \"$2\")"
101 else
102 opt_a="(\$2 == \"$2\")"
103 fi
104 SELECTED='y'
105 shift 2 ;;
106 -c|--cpu)
107 # echo "Option CPU: argument \`$2'"
108 if [ "$opt_c" ] ; then
Allen Martinaa2e2792012-08-31 08:30:06 +0000109 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200110 else
Allen Martinaa2e2792012-08-31 08:30:06 +0000111 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200112 fi
113 SELECTED='y'
114 shift 2 ;;
115 -s|--soc)
116 # echo "Option SoC: argument \`$2'"
117 if [ "$opt_s" ] ; then
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200118 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200119 else
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200120 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200121 fi
122 SELECTED='y'
123 shift 2 ;;
124 -v|--vendor)
125 # echo "Option VENDOR: argument \`$2'"
126 if [ "$opt_v" ] ; then
127 opt_v="${opt_v%)} || \$5 == \"$2\")"
128 else
129 opt_v="(\$5 == \"$2\")"
130 fi
131 SELECTED='y'
132 shift 2 ;;
Masahiro Yamada4d1584b2013-11-21 19:06:58 +0900133 -b|--board)
134 # echo "Option BOARD: argument \`$2'"
135 if [ "$opt_b" ] ; then
136 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
137 else
138 # We need to check the 7th field too
139 # for boards whose 6th field is "-"
140 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
141 fi
142 SELECTED='y'
143 shift 2 ;;
Kim Phillips33f336d2012-09-27 14:57:34 +0000144 -C|--check)
145 CHECK='C=1'
146 shift ;;
Joe Hershberger08510202012-10-30 15:55:21 +0000147 -n|--continue)
148 CONTINUE='y'
149 shift ;;
150 -r|--rebuild-errors)
151 REBUILD_ERRORS='y'
152 shift ;;
Marek Vasut7f79c6f2011-12-02 21:32:03 +0000153 -l|--list)
154 ONLY_LIST='y'
155 shift ;;
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000156 -m|--maintainers)
157 ONLY_LIST='y'
158 PRINT_MAINTS='y'
159 MAINTAINERS_ONLY='y'
160 shift ;;
161 -M|--mails)
162 ONLY_LIST='y'
163 PRINT_MAINTS='y'
164 shift ;;
Mike Frysingerd8e392d2011-04-21 22:01:43 +0000165 -h|--help)
166 usage ;;
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200167 --)
168 shift ; break ;;
169 *)
170 echo "Internal error!" >&2 ; exit 1 ;;
171 esac
172done
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900173
174GNU_MAKE=$(scripts/show-gnu-make) || {
175 echo "GNU Make not found" >&2
176 exit 1
177}
178
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200179# echo "Remaining arguments:"
180# for arg do echo '--> '"\`$arg'" ; done
181
Masahiro Yamada94ab8f42014-08-22 14:33:40 +0900182tools/genboardscfg.py || {
183 echo "Failed to generate boards.cfg" >&2
184 exit 1
185}
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900186
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200187FILTER="\$1 !~ /^#/"
188[ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
189[ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
190[ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
191[ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
Masahiro Yamada4d1584b2013-11-21 19:06:58 +0900192[ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200193
194if [ "$SELECTED" ] ; then
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200195 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
Peter Tysercd57b0b2010-10-29 17:59:06 -0500196
197 # Make sure some boards from boards.cfg are actually found
198 if [ -z "$SELECTED" ] ; then
199 echo "Error: No boards selected, invalid arguments"
200 exit 1
201 fi
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200202fi
203
204#########################################################################
205
Peter Tyser40a28f02009-09-21 12:04:32 -0500206# Print statistics when we exit
207trap exit 1 2 3 15
208trap print_stats 0
209
Wolfgang Denk7fa6a2f2008-12-09 00:39:08 +0100210# Determine number of CPU cores if no default was set
211: ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
212
213if [ "$BUILD_NCPUS" -gt 1 ]
214then
Peter Tyser55f786d2009-09-21 12:04:33 -0500215 JOBS="-j $((BUILD_NCPUS + 1))"
Wolfgang Denk7fa6a2f2008-12-09 00:39:08 +0100216else
217 JOBS=""
218fi
219
Marian Balakowiczf9328632006-09-01 19:49:50 +0200220if [ "${MAKEALL_LOGDIR}" ] ; then
221 LOG_DIR=${MAKEALL_LOGDIR}
222else
223 LOG_DIR="LOG"
224fi
Stefan Roese887e2ec2006-09-07 11:51:23 +0200225
Andy Flemingf588bb02012-04-24 19:33:51 +0000226: ${BUILD_NBUILDS:=1}
227BUILD_MANY=0
228
229if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
230 BUILD_MANY=1
231 : ${BUILD_DIR:=./build}
232 mkdir -p "${BUILD_DIR}/ERR"
233 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
Marian Balakowiczf9328632006-09-01 19:49:50 +0200234fi
235
Andy Flemingf588bb02012-04-24 19:33:51 +0000236: ${BUILD_DIR:=.}
237
238OUTPUT_PREFIX="${BUILD_DIR}"
239
240[ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
Joe Hershberger08510202012-10-30 15:55:21 +0000241if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
242 find "${LOG_DIR}/" -type f -exec rm -f {} +
243fi
wdenk7ebf7442002-11-02 23:17:16 +0000244
245LIST=""
246
Peter Tyser40a28f02009-09-21 12:04:32 -0500247# Keep track of the number of builds and errors
248ERR_CNT=0
249ERR_LIST=""
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000250WRN_CNT=0
251WRN_LIST=""
Peter Tyser40a28f02009-09-21 12:04:32 -0500252TOTAL_CNT=0
Joe Hershberger08510202012-10-30 15:55:21 +0000253SKIP_CNT=0
Andy Flemingf588bb02012-04-24 19:33:51 +0000254CURRENT_CNT=0
255OLDEST_IDX=1
Peter Tyserf2352872009-12-06 23:58:28 -0600256RC=0
Peter Tyser40a28f02009-09-21 12:04:32 -0500257
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400258# Helper funcs for parsing boards.cfg
Masahiro Yamada89487942013-10-21 11:11:28 +0900259targets_by_field()
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400260{
Masahiro Yamada8e5a2d42013-10-21 11:11:27 +0900261 field=$1
262 regexp=$2
263
264 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
265 boards.cfg
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400266}
Masahiro Yamada8e5a2d42013-10-21 11:11:27 +0900267
Masahiro Yamada89487942013-10-21 11:11:28 +0900268targets_by_arch() { targets_by_field 2 "$@" ; }
269targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
270targets_by_soc() { targets_by_field 4 "$@" ; }
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400271
wdenk7ebf7442002-11-02 23:17:16 +0000272#########################################################################
wdenk0db5bca2003-03-31 17:27:09 +0000273## MPC5xx Systems
274#########################################################################
275
Masahiro Yamada89487942013-10-21 11:11:28 +0900276LIST_5xx="$(targets_by_cpu mpc5xx)"
wdenk0db5bca2003-03-31 17:27:09 +0000277
278#########################################################################
wdenk945af8d2003-07-16 21:53:01 +0000279## MPC5xxx Systems
280#########################################################################
281
Masahiro Yamada89487942013-10-21 11:11:28 +0900282LIST_5xxx="$(targets_by_cpu mpc5xxx)"
wdenk945af8d2003-07-16 21:53:01 +0000283
284#########################################################################
Rafal Jaworowski8993e542007-07-27 14:43:59 +0200285## MPC512x Systems
286#########################################################################
287
Masahiro Yamada89487942013-10-21 11:11:28 +0900288LIST_512x="$(targets_by_cpu mpc512x)"
wdenk7ebf7442002-11-02 23:17:16 +0000289
290#########################################################################
291## MPC8xx Systems
292#########################################################################
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400293
Masahiro Yamada89487942013-10-21 11:11:28 +0900294LIST_8xx="$(targets_by_cpu mpc8xx)"
wdenk7ebf7442002-11-02 23:17:16 +0000295
296#########################################################################
297## PPC4xx Systems
298#########################################################################
299
Masahiro Yamada89487942013-10-21 11:11:28 +0900300LIST_4xx="$(targets_by_cpu ppc4xx)"
wdenk7ebf7442002-11-02 23:17:16 +0000301
302#########################################################################
wdenk7aa78612003-05-03 15:50:43 +0000303## MPC8260 Systems (includes 8250, 8255 etc.)
wdenk7ebf7442002-11-02 23:17:16 +0000304#########################################################################
305
Masahiro Yamada89487942013-10-21 11:11:28 +0900306LIST_8260="$(targets_by_cpu mpc8260)"
wdenk7ebf7442002-11-02 23:17:16 +0000307
308#########################################################################
Eran Libertyf046ccd2005-07-28 10:08:46 -0500309## MPC83xx Systems (includes 8349, etc.)
310#########################################################################
311
Masahiro Yamada89487942013-10-21 11:11:28 +0900312LIST_83xx="$(targets_by_cpu mpc83xx)"
Eran Libertyf046ccd2005-07-28 10:08:46 -0500313
314#########################################################################
wdenk42d1f032003-10-15 23:53:47 +0000315## MPC85xx Systems (includes 8540, 8560 etc.)
316#########################################################################
317
Masahiro Yamada89487942013-10-21 11:11:28 +0900318LIST_85xx="$(targets_by_cpu mpc85xx)"
wdenk42d1f032003-10-15 23:53:47 +0000319
320#########################################################################
Jon Loeliger822d5532007-05-23 14:09:46 -0500321## MPC86xx Systems
322#########################################################################
323
Masahiro Yamada89487942013-10-21 11:11:28 +0900324LIST_86xx="$(targets_by_cpu mpc86xx)"
Jon Loeliger822d5532007-05-23 14:09:46 -0500325
326#########################################################################
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700327## PowerPC groups
328#########################################################################
329
330LIST_TSEC=" \
331 ${LIST_83xx} \
332 ${LIST_85xx} \
333 ${LIST_86xx} \
334"
335
Stefan Roesea47a12b2010-04-15 16:07:28 +0200336LIST_powerpc=" \
Kim Phillipsfb565792007-08-10 15:34:48 -0500337 ${LIST_5xx} \
Jean-Christophe PLAGNIOL-VILLARD3deca9d2007-11-25 22:39:25 +0100338 ${LIST_512x} \
Kim Phillipsfb565792007-08-10 15:34:48 -0500339 ${LIST_5xxx} \
340 ${LIST_8xx} \
Kim Phillipsfb565792007-08-10 15:34:48 -0500341 ${LIST_824x} \
342 ${LIST_8260} \
343 ${LIST_83xx} \
344 ${LIST_85xx} \
345 ${LIST_86xx} \
346 ${LIST_4xx} \
Kim Phillipsfb565792007-08-10 15:34:48 -0500347"
wdenk7ebf7442002-11-02 23:17:16 +0000348
Stefan Roesea47a12b2010-04-15 16:07:28 +0200349# Alias "ppc" -> "powerpc" to not break compatibility with older scripts
350# still using "ppc" instead of "powerpc"
351LIST_ppc=" \
352 ${LIST_powerpc} \
353"
354
wdenk7ebf7442002-11-02 23:17:16 +0000355#########################################################################
356## StrongARM Systems
357#########################################################################
358
Masahiro Yamada89487942013-10-21 11:11:28 +0900359LIST_SA="$(targets_by_cpu sa1100)"
wdenk7ebf7442002-11-02 23:17:16 +0000360
361#########################################################################
Allen Martincce5d212012-08-29 11:08:59 +0000362## ARM7 Systems
363#########################################################################
364
Masahiro Yamada89487942013-10-21 11:11:28 +0900365LIST_ARM7="$(targets_by_cpu arm720t)"
Allen Martincce5d212012-08-29 11:08:59 +0000366
367#########################################################################
wdenk7ebf7442002-11-02 23:17:16 +0000368## ARM9 Systems
369#########################################################################
370
Masahiro Yamada89487942013-10-21 11:11:28 +0900371LIST_ARM9="$(targets_by_cpu arm920t) \
372 $(targets_by_cpu arm926ejs) \
373 $(targets_by_cpu arm946es) \
wdenk6f213472003-08-29 22:00:43 +0000374"
wdenk7ebf7442002-11-02 23:17:16 +0000375
376#########################################################################
wdenk8ed96042005-01-09 23:16:25 +0000377## ARM11 Systems
378#########################################################################
Masahiro Yamada89487942013-10-21 11:11:28 +0900379LIST_ARM11="$(targets_by_cpu arm1136) \
380 $(targets_by_cpu arm1176) \
Allen Martincce5d212012-08-29 11:08:59 +0000381"
wdenk8ed96042005-01-09 23:16:25 +0000382
383#########################################################################
Steve Sakomanf56348a2010-06-17 21:50:01 -0700384## ARMV7 Systems
Dirk Behmef904cdb2009-01-27 18:19:12 +0100385#########################################################################
Dirk Behmef37586b2011-08-05 20:48:32 +0000386
Masahiro Yamada89487942013-10-21 11:11:28 +0900387LIST_ARMV7="$(targets_by_cpu armv7)"
Dirk Behmef904cdb2009-01-27 18:19:12 +0100388
389#########################################################################
David Feng2475e632013-12-14 11:47:38 +0800390## ARMV8 Systems
391#########################################################################
392
393LIST_ARMV8="$(targets_by_cpu armv8)"
394
395#########################################################################
Jean-Christophe PLAGNIOL-VILLARD602cac12008-05-24 12:47:46 +0200396## AT91 Systems
397#########################################################################
398
Masahiro Yamada89487942013-10-21 11:11:28 +0900399LIST_at91="$(targets_by_soc at91)"
Jean-Christophe PLAGNIOL-VILLARD602cac12008-05-24 12:47:46 +0200400
401#########################################################################
wdenk7ebf7442002-11-02 23:17:16 +0000402## Xscale Systems
403#########################################################################
404
Masahiro Yamada89487942013-10-21 11:11:28 +0900405LIST_pxa="$(targets_by_cpu pxa)"
wdenk7ebf7442002-11-02 23:17:16 +0000406
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700407#########################################################################
Stefan Roese24dede42012-05-30 22:59:43 +0000408## SPEAr Systems
409#########################################################################
410
Masahiro Yamada89487942013-10-21 11:11:28 +0900411LIST_spear="$(targets_by_soc spear)"
Stefan Roese24dede42012-05-30 22:59:43 +0000412
413#########################################################################
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700414## ARM groups
415#########################################################################
wdenk2d5b5612003-10-14 19:43:55 +0000416
David Feng2475e632013-12-14 11:47:38 +0800417LIST_arm="$(targets_by_arch arm | \
418 for ARMV8_TARGET in $LIST_ARMV8; \
419 do sed "/$ARMV8_TARGET/d"; \
420 done) \
421"
wdenk7ebf7442002-11-02 23:17:16 +0000422
wdenkc0218802003-03-27 12:09:35 +0000423#########################################################################
Wolfgang Denkb62bdff2005-08-14 00:27:00 +0200424## MIPS Systems (default = big endian)
wdenkc0218802003-03-27 12:09:35 +0000425#########################################################################
426
Daniel Schwierzecked638b62014-04-17 21:45:59 +0200427LIST_mips="$(targets_by_arch mips)"
wdenkc0218802003-03-27 12:09:35 +0000428
Stefan Kristianssondeddf5d2011-11-18 19:21:37 +0000429#########################################################################
430## OpenRISC Systems
431#########################################################################
432
Masahiro Yamada89487942013-10-21 11:11:28 +0900433LIST_openrisc="$(targets_by_arch openrisc)"
Wolfgang Denkb62bdff2005-08-14 00:27:00 +0200434
435#########################################################################
Graeme Russfea25722011-04-13 19:43:28 +1000436## x86 Systems
wdenk7a8e9bed2003-05-31 18:35:21 +0000437#########################################################################
438
Masahiro Yamada89487942013-10-21 11:11:28 +0900439LIST_x86="$(targets_by_arch x86)"
wdenk7a8e9bed2003-05-31 18:35:21 +0000440
wdenkc935d3b2004-01-03 19:43:48 +0000441#########################################################################
wdenk5c952cf2004-10-10 21:27:30 +0000442## Nios-II Systems
443#########################################################################
444
Masahiro Yamada89487942013-10-21 11:11:28 +0900445LIST_nios2="$(targets_by_arch nios2)"
wdenk5c952cf2004-10-10 21:27:30 +0000446
447#########################################################################
wdenk857cad32004-07-10 23:48:41 +0000448## MicroBlaze Systems
449#########################################################################
450
Masahiro Yamada89487942013-10-21 11:11:28 +0900451LIST_microblaze="$(targets_by_arch microblaze)"
wdenk857cad32004-07-10 23:48:41 +0000452
Zachary P. Landauf8c3b4f2006-01-26 17:38:46 -0500453#########################################################################
454## ColdFire Systems
455#########################################################################
456
Masahiro Yamada89487942013-10-21 11:11:28 +0900457LIST_m68k="$(targets_by_arch m68k)"
Mike Frysingerc13f47b2011-09-25 19:27:19 +0000458LIST_coldfire=${LIST_m68k}
Zachary P. Landauf8c3b4f2006-01-26 17:38:46 -0500459
Wolfgang Denk6ccec442006-10-24 14:42:37 +0200460#########################################################################
461## AVR32 Systems
462#########################################################################
463
Masahiro Yamada89487942013-10-21 11:11:28 +0900464LIST_avr32="$(targets_by_arch avr32)"
Wolfgang Denk6ccec442006-10-24 14:42:37 +0200465
Aubrey.Lief26a082007-03-09 13:40:56 +0800466#########################################################################
467## Blackfin Systems
468#########################################################################
469
Masahiro Yamada89487942013-10-21 11:11:28 +0900470LIST_blackfin="$(targets_by_arch blackfin)"
Aubrey.Lief26a082007-03-09 13:40:56 +0800471
Jean-Christophe PLAGNIOL-VILLARDc7144372007-11-27 09:44:53 +0100472#########################################################################
473## SH Systems
474#########################################################################
475
Masahiro Yamada89487942013-10-21 11:11:28 +0900476LIST_sh2="$(targets_by_cpu sh2)"
477LIST_sh3="$(targets_by_cpu sh3)"
478LIST_sh4="$(targets_by_cpu sh4)"
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700479
Masahiro Yamada89487942013-10-21 11:11:28 +0900480LIST_sh="$(targets_by_arch sh)"
Jean-Christophe PLAGNIOL-VILLARDc7144372007-11-27 09:44:53 +0100481
Daniel Hellstromc2f02da2008-03-28 09:47:00 +0100482#########################################################################
483## SPARC Systems
484#########################################################################
485
Masahiro Yamada89487942013-10-21 11:11:28 +0900486LIST_sparc="$(targets_by_arch sparc)"
wdenk7ebf7442002-11-02 23:17:16 +0000487
Macpaul Lin5f1719c2011-10-19 20:41:10 +0000488#########################################################################
489## NDS32 Systems
490#########################################################################
491
Masahiro Yamada89487942013-10-21 11:11:28 +0900492LIST_nds32="$(targets_by_arch nds32)"
Macpaul Lin5f1719c2011-10-19 20:41:10 +0000493
Alexey Brodkin568c1fa2014-02-04 12:56:20 +0400494#########################################################################
495## ARC Systems
496#########################################################################
497
498LIST_arc="$(targets_by_arch arc)"
499
wdenk7ebf7442002-11-02 23:17:16 +0000500#-----------------------------------------------------------------------
501
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000502get_target_location() {
503 local target=$1
504 local BOARD_NAME=""
505 local CONFIG_NAME=""
506 local board=""
507 local vendor=""
508
509 # Automatic mode
Masahiro Yamada23d64102013-10-21 11:11:25 +0900510 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000511 if [ -z "${line}" ] ; then echo "" ; return ; fi
512
513 set ${line}
514
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900515 CONFIG_NAME="${7%_defconfig}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000516
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900517 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000518
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200519 if [ $# -gt 5 ]; then
520 if [ "$6" = "-" ] ; then
521 board=${BOARD_NAME}
522 else
523 board="$6"
524 fi
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000525 fi
526
527 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200528 [ $# -gt 6 ] && [ "$8" != "-" ] && {
529 tmp="${8%:*}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000530 if [ "$tmp" ] ; then
531 CONFIG_NAME="$tmp"
532 fi
533 }
534
535 # Assign board directory to BOARDIR variable
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200536 if [ "${vendor}" == "-" ] ; then
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000537 BOARDDIR=${board}
538 else
539 BOARDDIR=${vendor}/${board}
540 fi
541
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200542 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000543}
544
545get_target_maintainers() {
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200546 local name=`echo $1 | cut -d : -f 3`
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000547
Masahiro Yamada23d64102013-10-21 11:11:25 +0900548 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200549 if [ -z "${line}" ]; then
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000550 echo ""
551 return ;
552 fi
553
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200554 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
555 [ "$mails" == "-" ] && mails=""
556 echo "$mails"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000557}
558
Allen Martin47104c32013-01-29 14:34:58 +0000559get_target_arch() {
560 local target=$1
561
Masahiro Yamadabf678df2015-04-06 11:12:28 +0900562 awk '$7 == "'$target'" { print $2 }' boards.cfg
Allen Martin47104c32013-01-29 14:34:58 +0000563}
564
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000565list_target() {
566 if [ "$PRINT_MAINTS" != 'y' ] ; then
567 echo "$1"
568 return
569 fi
570
571 echo -n "$1:"
572
573 local loc=`get_target_location $1`
574
575 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
576
577 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
578
579 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
580
581 local dir=`echo ${loc} | cut -d ":" -f 2`
582 local cfg=`echo ${loc} | cut -d ":" -f 1`
583 local git_result=`git log --format=%aE board/${dir} \
584 include/configs/${cfg}.h | grep "@"`
585 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
586 head -n 3`
587 local git_result_top=`echo ${git_result} | tr " " "\n" | \
588 sort | uniq -c | sort -nr | head -n 3 | \
589 sed "s/^ \+[0-9]\+ \+//"`
590
591 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
592 sort -u | tr "\n" " " | sed "s/ $//" ;
593 else
594 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
595 sed "s/ $//" ;
596 fi
597
598 echo ""
599}
600
Andy Flemingf588bb02012-04-24 19:33:51 +0000601# Each finished build will have a file called ${donep}${n},
602# where n is the index of the build. Each build
603# we've already noted as finished will have ${skipp}${n}.
604# The code managing the build process will use this information
605# to ensure that only BUILD_NBUILDS builds are in flight at once
606donep="${LOG_DIR}/._done_"
607skipp="${LOG_DIR}/._skip_"
608
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000609build_target_killed() {
610 echo "Aborted $target build."
611 # Remove the logs for this board since it was aborted
612 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
613 exit
614}
615
wdenk7ebf7442002-11-02 23:17:16 +0000616build_target() {
617 target=$1
Andy Flemingf588bb02012-04-24 19:33:51 +0000618 build_idx=$2
619
Andy Flemingf50bf502012-05-09 20:36:28 +0000620 if [ "$ONLY_LIST" == 'y' ] ; then
621 list_target ${target}
622 return
623 fi
624
Andy Flemingf588bb02012-04-24 19:33:51 +0000625 if [ $BUILD_MANY == 1 ] ; then
626 output_dir="${OUTPUT_PREFIX}/${target}"
627 mkdir -p "${output_dir}"
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000628 trap build_target_killed TERM
Andy Flemingf588bb02012-04-24 19:33:51 +0000629 else
630 output_dir="${OUTPUT_PREFIX}"
631 fi
632
Allen Martin47104c32013-01-29 14:34:58 +0000633 target_arch=$(get_target_arch ${target})
York Sunc17b94e2013-03-22 07:37:03 +0000634 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
Allen Martin47104c32013-01-29 14:34:58 +0000635 if [ "${cross_toolchain}" ] ; then
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900636 MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
Allen Martin47104c32013-01-29 14:34:58 +0000637 elif [ "${CROSS_COMPILE}" ] ; then
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900638 MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
Allen Martin47104c32013-01-29 14:34:58 +0000639 else
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900640 MAKE=$GNU_MAKE
Allen Martin47104c32013-01-29 14:34:58 +0000641 fi
642
Masahiro Yamada9e414032014-02-04 17:24:24 +0900643 if [ "${output_dir}" != "." ] ; then
644 MAKE="${MAKE} O=${output_dir}"
645 fi
646
Roger Meierfd18a892014-08-20 22:10:29 +0200647 ${MAKE} mrproper >/dev/null
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900648
649 echo "Building ${target} board..."
650 ${MAKE} -s ${target}_defconfig >/dev/null
Marian Balakowiczf9328632006-09-01 19:49:50 +0200651
Kim Phillips33f336d2012-09-27 14:57:34 +0000652 ${MAKE} ${JOBS} ${CHECK} all \
Andy Flemingf588bb02012-04-24 19:33:51 +0000653 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
Peter Tyserf2352872009-12-06 23:58:28 -0600654
655 # Check for 'make' errors
656 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
657 RC=1
658 fi
659
Joe Hershbergere71796a2015-03-11 18:47:33 -0500660 OBJS=${output_dir}/u-boot
661 if [ -e ${output_dir}/spl/u-boot-spl ]; then
662 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
663 fi
664
665 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
666
Andy Flemingf588bb02012-04-24 19:33:51 +0000667 if [ $BUILD_MANY == 1 ] ; then
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000668 trap - TERM
669
Masahiro Yamada73906432014-02-04 17:24:34 +0900670 ${MAKE} -s clean
Andy Flemingf588bb02012-04-24 19:33:51 +0000671
672 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000673 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
Andy Flemingf588bb02012-04-24 19:33:51 +0000674 else
675 rm ${LOG_DIR}/${target}.ERR
676 fi
Peter Tyser40a28f02009-09-21 12:04:32 -0500677 else
Andy Flemingf588bb02012-04-24 19:33:51 +0000678 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000679 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
680 : $(( ERR_CNT += 1 ))
681 ERR_LIST="${ERR_LIST} $target"
682 else
683 : $(( WRN_CNT += 1 ))
684 WRN_LIST="${WRN_LIST} $target"
685 fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000686 else
687 rm ${LOG_DIR}/${target}.ERR
688 fi
Peter Tyser40a28f02009-09-21 12:04:32 -0500689 fi
690
Andy Flemingf588bb02012-04-24 19:33:51 +0000691 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
692
Andy Flemingf588bb02012-04-24 19:33:51 +0000693 touch "${donep}${build_idx}"
wdenk7ebf7442002-11-02 23:17:16 +0000694}
Andy Flemingf588bb02012-04-24 19:33:51 +0000695
696manage_builds() {
697 search_idx=${OLDEST_IDX}
Andy Flemingf50bf502012-05-09 20:36:28 +0000698 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
699
Andy Flemingf588bb02012-04-24 19:33:51 +0000700 while true; do
701 if [ -e "${donep}${search_idx}" ] ; then
Andy Flemingf588bb02012-04-24 19:33:51 +0000702 : $(( CURRENT_CNT-- ))
703 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
704 : $(( OLDEST_IDX++ ))
705
706 # Only want to count it once
707 rm -f "${donep}${search_idx}"
708 touch "${skipp}${search_idx}"
709 elif [ -e "${skipp}${search_idx}" ] ; then
710 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
711 : $(( OLDEST_IDX++ ))
712 fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000713 : $(( search_idx++ ))
714 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
Andy Flemingf588bb02012-04-24 19:33:51 +0000715 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
716 search_idx=${OLDEST_IDX}
717 sleep 1
718 else
719 break
720 fi
721 fi
722 done
723}
724
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400725build_targets() {
726 for t in "$@" ; do
727 # If a LIST_xxx var exists, use it. But avoid variable
728 # expansion in the eval when a board name contains certain
729 # characters that the shell interprets.
730 case ${t} in
731 *[-+=]*) list= ;;
732 *) list=$(eval echo '${LIST_'$t'}') ;;
733 esac
734 if [ -n "${list}" ] ; then
735 build_targets ${list}
736 else
Andy Flemingf588bb02012-04-24 19:33:51 +0000737 : $((TOTAL_CNT += 1))
738 : $((CURRENT_CNT += 1))
739 rm -f "${donep}${TOTAL_CNT}"
740 rm -f "${skipp}${TOTAL_CNT}"
Joe Hershberger08510202012-10-30 15:55:21 +0000741 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
742 : $((SKIP_CNT += 1))
743 touch "${donep}${TOTAL_CNT}"
744 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
745 : $((SKIP_CNT += 1))
746 touch "${donep}${TOTAL_CNT}"
Joe Hershbergerb594bd62012-05-21 04:49:37 +0000747 else
Joe Hershberger08510202012-10-30 15:55:21 +0000748 if [ $BUILD_MANY == 1 ] ; then
749 build_target ${t} ${TOTAL_CNT} &
750 else
751 CUR_TGT="${t}"
752 build_target ${t} ${TOTAL_CNT}
753 CUR_TGT=''
754 fi
Joe Hershbergerb594bd62012-05-21 04:49:37 +0000755 fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000756 fi
757
758 # We maintain a running count of all the builds we have done.
759 # Each finished build will have a file called ${donep}${n},
760 # where n is the index of the build. Each build
761 # we've already noted as finished will have ${skipp}${n}.
762 # We track the current index via TOTAL_CNT, and the oldest
763 # index. When we exceed the maximum number of parallel builds,
764 # We look from oldest to current for builds that have completed,
765 # and update the current count and oldest index as appropriate.
766 # If we've gone through the entire list, wait a second, and
767 # reprocess the entire list until we find a build that has
768 # completed
769 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
770 manage_builds
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400771 fi
772 done
773}
wdenk7ebf7442002-11-02 23:17:16 +0000774
775#-----------------------------------------------------------------------
776
Andy Flemingf50bf502012-05-09 20:36:28 +0000777kill_children() {
Andreas Bießmann6bdd9f82013-02-07 22:35:57 +0000778 local OS=$(uname -s)
779 local children=""
780 case "${OS}" in
781 "Darwin")
782 # Mac OS X is known to have BSD style ps
783 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
784 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
785 ;;
786 *)
787 # everything else tries the GNU style
788 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
789 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
790 ;;
791 esac
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000792
793 kill $children 2> /dev/null
794 wait $children 2> /dev/null
Andy Flemingf50bf502012-05-09 20:36:28 +0000795
796 exit
797}
798
Peter Tyser40a28f02009-09-21 12:04:32 -0500799print_stats() {
Marek Vasut7f79c6f2011-12-02 21:32:03 +0000800 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000801
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000802 # Only count boards that completed
803 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
804
Andy Flemingf588bb02012-04-24 19:33:51 +0000805 rm -f ${donep}* ${skipp}*
806
807 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
Andy Fleming033220e2012-08-08 14:12:30 +0000808 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000809 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
810 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
Andy Fleming033220e2012-08-08 14:12:30 +0000811 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000812 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
813 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000814 else
815 # Remove the logs for any board that was interrupted
816 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
Andy Flemingf588bb02012-04-24 19:33:51 +0000817 fi
818
Joe Hershberger08510202012-10-30 15:55:21 +0000819 : $((TOTAL_CNT -= ${SKIP_CNT}))
Peter Tyser40a28f02009-09-21 12:04:32 -0500820 echo ""
821 echo "--------------------- SUMMARY ----------------------------"
Joe Hershberger08510202012-10-30 15:55:21 +0000822 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
823 echo "Boards skipped: ${SKIP_CNT}"
824 fi
Peter Tyser40a28f02009-09-21 12:04:32 -0500825 echo "Boards compiled: ${TOTAL_CNT}"
826 if [ ${ERR_CNT} -gt 0 ] ; then
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000827 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
828 fi
829 if [ ${WRN_CNT} -gt 0 ] ; then
830 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
Peter Tyser40a28f02009-09-21 12:04:32 -0500831 fi
832 echo "----------------------------------------------------------"
Peter Tyserf2352872009-12-06 23:58:28 -0600833
Andy Flemingf50bf502012-05-09 20:36:28 +0000834 if [ $BUILD_MANY == 1 ] ; then
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000835 kill_children
Andy Flemingf50bf502012-05-09 20:36:28 +0000836 fi
837
Simon Glassf4815762014-08-28 09:43:46 -0600838 deprecation
839
Peter Tyserf2352872009-12-06 23:58:28 -0600840 exit $RC
Peter Tyser40a28f02009-09-21 12:04:32 -0500841}
wdenk7ebf7442002-11-02 23:17:16 +0000842
Peter Tyser40a28f02009-09-21 12:04:32 -0500843#-----------------------------------------------------------------------
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400844
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200845# Build target groups selected by options, plus any command line args
846set -- ${SELECTED} "$@"
847# run PowerPC by default
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400848[ $# = 0 ] && set -- powerpc
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400849build_targets "$@"
Andy Flemingf588bb02012-04-24 19:33:51 +0000850wait